function XYZxyz = PostoGrid(Miniz,MiniX,MiniY,zStack,xpos,ypos,FinalImages3D,XYZ)
% zStack is the um thickness of each z slice
% xpos is pixelsize in x
% ypos is pixelsize in y
% FinalImages3D is the image file imported
% XYZ is the position file imported
%% puts z-slice info for every cell
Arrz = zeros(size(FinalImages3D{1,1},3),1);

for i = 1:(size(FinalImages3D{1,1},3))
    Arrz(i,1) = Miniz+zStack;
    Miniz = Miniz+zStack;
end

% applies the zStack ID to each object identified
z = zeros(size(XYZ,1),1);
XYZz = [XYZ, z];

for i = 1:(size(XYZ,1))
    for j = 1:(size(FinalImages3D{1,1},3))
        if j == 1
            if XYZ(i,3) <= Arrz(j,1)
                XYZz(i,4) = 1;
            end
        else
            if XYZ(i,3) <= Arrz(j,1) & XYZ(i,3) > Arrz(j-1,1)
                XYZz(i,4) = j;
            end
        end
    end
end

%% puts x-position info for every cell

%xpos = str2double(get(handles.redfactor,'string'))*(str2double(get(handles.editX,'String')));
ArrX = zeros(size(FinalImages3D{1,1},2),1);

for i = 1:(size(FinalImages3D{1,1},2))
    ArrX(i,1) = MiniX+xpos;
    MiniX = MiniX+xpos;
end

% applies the x-position ID to each object identified
x = zeros(size(XYZ,1),1);
XYZx = [XYZ, x];

for i = 1:(size(XYZ,1))
    for j = 1:(size(FinalImages3D{1,1},2))
        if j == 1
            if XYZ(i,1) <= ArrX(j,1)
                XYZx(i,4) = 1;
            end
        else
            if XYZ(i,1) <= ArrX(j,1) & XYZ(i,1) > ArrX(j-1,1)
                XYZx(i,4) = j;
            end
        end
    end
end
in = find(XYZx(:,4) == 0);
XYZx(in,4) = size(FinalImages3D{1,1},2);

%% puts y-position info for every cell
%ypos = str2double(get(handles.redfactor,'string'))*(str2double(get(handles.editY,'String')));
ArrY = zeros(size(FinalImages3D{1,1},1),1);

for i = 1:(size(FinalImages3D{1,1},1))
    ArrY(i,1) = MiniY+ypos;
    MiniY = MiniY+ypos;
end

% applies the y-position ID to each object identified
y = zeros(size(XYZ,1),1);
XYZy = [XYZ, y];

for i = 1:(size(XYZ,1))
    for j = 1:(size(FinalImages3D{1,1},1))
        if j == 1
            if XYZ(i,2) <= ArrY(j,1)
                XYZy(i,4) = 1;
            end
        else
            if XYZ(i,2) <= ArrY(j,1) & XYZ(i,2) > ArrY(j-1,1)
                XYZy(i,4) = j;
            end
        end
    end
end
in2 = find(XYZy(:,4) == 0);
XYZy(in2,4) = size(FinalImages3D{1,1},1);

XYZxyz = [XYZ XYZx(:,4) XYZy(:,4) XYZz(:,4)];
